#pragma once
#include "IDessinable.h"
#include <vector>
#include "Autonome.h"
class Camera;

// ActiveXTestCtrl.h : dclaration de la classe du contrle ActiveX CActiveXTestCtrl.


// CActiveXTestCtrl : consultez ActiveXTestCtrl.cpp pour l'implmentation.

class CActiveXTestCtrl : public COleControl, public virtual Autonome
{
	DECLARE_DYNCREATE(CActiveXTestCtrl)

// Constructeur
public:
	CActiveXTestCtrl();

// Overrides
public:
	//virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();

// Implmentation
protected:
	~CActiveXTestCtrl();

	DECLARE_OLECREATE_EX(CActiveXTestCtrl)    // Fabrique de classe et guid
	DECLARE_OLETYPELIB(CActiveXTestCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CActiveXTestCtrl)     // ID de page de proprits
	DECLARE_OLECTLTYPE(CActiveXTestCtrl)		// Nom de type et tat divers

// Tables des messages
	DECLARE_MESSAGE_MAP()

// Tables de dispatch
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Tables d'vnements
	DECLARE_EVENT_MAP()

// ID de dispatch et d'vnement
public:
	enum {
	};
private:
   //
   // Rotation on/off
   //
   bool m_RotationActive;
   HANDLE hTh;
   // Initialiser les paramtres de l'animation et prparer la 1ire image
   bool InitAnimation();
   // Animer la scne
   bool AnimeScene (float TempsEcoule);
   // Nettoyage...
   void Nettoyer ();
   long m_TempsCourant;
   long m_TempsSuivant;
   long m_TempsVieux;
   DWORD m_TempsEcart;
   double m_EchelleTemps;
   float m_Rotation;
   IDirect3D9 *m_pD3D; // reprsente D3D et le matriel sous-jacent
   IDirect3DDevice9 *m_pD3DDevice; // reprsente le dispositif d'affichage
   // Ce qui sera affich
   Camera *m_pCamera;
   // Ce qui sera affich
   std::vector<IDessinable *> m_ObjetsDessinables;
   //
   // Gestion du thread (boboche)
   //
   bool m_Meurs;
public:
   //
   // Gestion du thread (boboche)
   //
   void Meurs () { m_Meurs = true; }
   bool DoisMourir () const { return m_Meurs; }
   // Prparer une image dans le backbuffer. En version optimise, cette
   // mthode ne fait pas d'affichage
   bool RendreScene();
   // Mthode d'animation. Optimise pour les systmes les moins rapides
   // (effectue le flip au dbut du signal, puis construit la prochaine
   // image).
   bool Animation ();
   // Initialisation de D3D
   void InitDirect3D();
   // Initialisation de la scne
   bool InitScene();
   // Initialisation des objets 3D (cration / chargement)
   bool InitObjets();
   // Initialisation des clairages
   bool InitEclairage();
   // Initialisation des transformations
   bool InitTransformations();
   //
   // Pour Autonome
   //
   void Agir ();
   afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
   afx_msg void OnDestroy();
   afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
   void ToggleRotation() { m_RotationActive = !m_RotationActive; }
   afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
};

