#ifndef BLOC_H
#define BLOC_H

#include "stdafx.h"
#include "IDessinable.h"

class Bloc : public IDessinable
{
   IDirect3DVertexBuffer9 *m_pVB; // vertex buffer du bloc
   IDirect3DIndexBuffer9 *m_pIB; // index buffer du bloc
   D3DMATERIAL9 m_Materiau; // matriau du bloc
   enum
   {
      NB_FACES = 6,
      NB_SOMMETS_PAR_FACE = 4,
      NB_SOMMETS_DISTINCTS = 8,
      NB_SOMMETS = NB_FACES * NB_SOMMETS_PAR_FACE,
      NB_SOMMETS_PRIMITIVE = 3, // des triangles
      NB_PRIMITIVES = 2 * NB_FACES, // deux triangles par carr
      NB_SOMMETS_PRIMITIVES = NB_PRIMITIVES * NB_SOMMETS_PRIMITIVE
   };
   static const WORD IndexBloc[NB_SOMMETS_PRIMITIVES]; // CNS
   void InitIndexBuffer (IDirect3DDevice9 *pDevice);
public:
   Bloc ();
   Bloc (D3DXVECTOR3 origine, D3DXVECTOR3 dimension,
         IDirect3DDevice9 *pDevice);
   virtual ~Bloc ();

   void SetMateriaux (const D3DMATERIAL9 &Materiau);
   void InitMateriaux ();
   virtual void Draw(IDirect3DDevice9 *pDevice);
   virtual void DrawNoTransform(IDirect3DDevice9 *pDevice);
};

#endif // !defined BLOC_H
