#include "Village.h"
#include "Maison.h"
#include "Plan.h"
#include <algorithm>

Village::Village (IDirect3DDevice9 *pDevice)
   : IDessinable (D3DXVECTOR3(0.0f, 0.0f, 0.0f)),
     m_Sol (new Plan (D3DXVECTOR3(0.0f, 0.0f, -0.1f), pDevice, 2, 4))
{
   m_Maisons.push_back (new Maison (D3DXVECTOR3 (0.0f, 0.0f, 0.0f), pDevice));
   m_Maisons.push_back (new Maison (D3DXVECTOR3 (5.0f, 0.0f, 0.0f), pDevice));
   m_Maisons.push_back (new Maison (D3DXVECTOR3 (0.0f, 5.0f, 0.0f), pDevice));
}

namespace
{
   template<class T> void Detruire (T *p) { delete p; }
   class Dessiner
   {
      IDirect3DDevice9 *m_pDevice;
   public:
      Dessiner (IDirect3DDevice9 *pDevice) : m_pDevice (pDevice) { }
      virtual ~Dessiner () { }
      void operator () (IDessinable *p) { p->DrawNoTransform (m_pDevice); }
   };
}

Village::~Village()
{
   std::for_each (m_Maisons.begin (), m_Maisons.end(), ::Detruire<Maison>);
   delete m_Sol;
}

void Village::Draw(IDirect3DDevice9 *pDevice)
{
   // Matrice de transformation dans le monde
   pDevice->SetTransform (D3DTS_WORLD, &m_MatriceMonde);
   DrawNoTransform (pDevice);
}

void Village::DrawNoTransform(IDirect3DDevice9 *pDevice)
{
   std::for_each (m_Maisons.begin (), m_Maisons.end(), ::Dessiner(pDevice));
   m_Sol->DrawNoTransform (pDevice);
}
